using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using answer = pair<double, int>;

int main() {
    int n;
    cin >> n;

    vector < pair < pair < int, int >, int >> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.first >> a[i].first.second;
        a[i].second = i + 1;
    }
    sort(a.begin(), a.end());
    set < pair < pair < int, int >, int >> q;
    vector<int> ans;
    int pos = 0;
    for (int i = 0; i < n; ++i) {
        while (pos < n && a[pos].first.first <= i + 1) {
            q.emplace(make_pair(a[pos].first.second, a[pos].first.first), a[pos].second);
            ++pos;
        }
        if (q.empty() || q.begin()->first.first < i + 1) {
            cout << "NO\n";
            return 0;
        }
        ans.push_back(q.begin()->second);
        q.erase(q.begin());
    }

    cout << "YES\n";
    for (int e: ans) {
        cout << e << " ";
    }
    cout << "\n";
}