using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using answer = pair<ll, int>;


int main() {
    int n, s;

    cin >> n >> s;
    --s;

    vector <vector<int>> d(n);
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        d[u].push_back(v);
        d[v].push_back(u);
    }

    function < answer(int, int, ll) > dfs = [&](int u, int p, ll speed) {
//        cout << "speed on " << (u + 1) << " " << speed << "\n";
        answer max_speed = make_pair(speed, u);
        for (int v: d[u]) {
            if (v == p) continue;
            ll new_speed = max(speed - a[u] + a[v], speed - b[u] + b[v]);
            max_speed = max(max_speed, dfs(v, u, new_speed));
        }
        return max_speed;
    };

    auto x = dfs(s, -1, 1);
    cout << x.first << "\n";
//    cout << x.first << "\n" << x.second + 1 << "\n";
}