#include <bits/stdc++.h>
using namespace std;

#define int long long

#define N 510000

int scost[N], sn;
vector<pair<int, int>> row[N];
vector<pair<pair<int, int>, int>> seg[N];
vector<int> g[N];
int res[N];

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int h, w, n; cin >> h >> w >> n;
    for (int k = 0; k < n; k++) {
        int i, j; char c; cin >> i >> j >> c;
        if (c == '#') row[i].push_back({j, 0});
        else {
			int d; cin >> d;
			row[i].push_back({j, d});
        }
    }
    sn = 0;
    for (int i = 1; i <= h; i++) {
		sort(begin(row[i]), end(row[i]));
        row[i].push_back({w + 1, 0});
        int cur = 0, beg = 1;
        for (auto pcost : row[i]) {
            auto p = pcost.first;
			auto cost = pcost.second;
			if (cost == 0) {
                if (beg < p) {
					scost[sn] = cur;
					seg[i].push_back({{beg, p - 1}, sn++});
                }
                cur = 0, beg = p + 1;
			}
            cur += cost;
        }
    }
    for (int i = 1; i + 1 <= h; i++) {
		int ptr = 0;
        for (auto lrv : seg[i]) {
			auto l = lrv.first.first;
			auto r = lrv.first.second;
			auto v = lrv.second;
            while (ptr < seg[i + 1].size() &&
					seg[i + 1][ptr].first.second <= r) {
                        if (seg[i + 1][ptr].first.second >= l)
							g[v].push_back(seg[i + 1][ptr].second);
                        ptr++;
					}
            if (ptr < seg[i + 1].size() &&
				seg[i + 1][ptr].first.first <= r)
					g[v].push_back(seg[i + 1][ptr].second);
        }
    }
    for (int i = 0; i < sn; i++) res[i] = 0;
    for (int i = 0; i < sn; i++) {
        res[i] += scost[i];
        for (int j : g[i]) res[j] = max(res[j], res[i]);
    }
	cout << res[sn - 1];
}
