using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using point = tuple<int, int, char>;

const ll MAX = LLONG_MAX;

int main() {
    int h, w, n;

    cin >> h >> w >> n;

//    vector < vector < pair < int, char>>> rows(h);
    vector <vector<ll>> a(h, vector<ll>(n, 0));
    vector <vector<ll>> dp(h, vector<ll>(n, -1));
    dp[0][0] = 0;

    for (int i = 0; i < n; ++i) {
        char t;
        int x, y;
        cin >> y >> x >> t;
        --x, --y;
        ll d = -1;
        if (t == '+') {
            cin >> d;
        }
        a[y][x] = d;
    }
//    for (int y = 0; y < h; ++y) {
//        sort(rows[y].begin(), rows[y].end());
//    }
    dp[0][0] = 0;
    for (int y = 0; y < h; ++y) {
        for (int x1 = 0; x1 < w; ++x1) {
            if (a[y][x1] == -1) {
//                cout << y << " " << x1 << " skiped\n";
                continue;
            }
            int x2 = x1;
            ll b = 0;
            ll p = y == 0 && x1 == 0 ? 0 : -1;
            while (x2 < w && a[y][x2] > -1) {
                if (y > 0 && a[y - 1][x2] >= 0) {
                    p = max(p, dp[y - 1][x2]);
                }
                b += a[y][x2++];
            }
            if (p == -1) {
//                cout << y << " " << x1 << "->" << x2 << " skiped by nothing\n";
                continue;
            }
//            cout << y << " " << x1 << "->" << x2 << "\n";
            for (int x = x1; x < x2; ++x) {
                dp[y][x] = p + b;
            }
            x1 = x2;
        }
//        for (int x = 0; x < w ;++x) {
//            cout << a[y][x] << " ";
//        }
//        cout << "\n";
//        for (int x = 0; x < w ;++x) {
//            cout << dp[y][x] << " ";
//        }
//        cout << "\n";
    }
    cout << dp[h - 1][w - 1] << "\n";
}