#include "testlib.h"
#include <iostream>
#include <unordered_set>
#include <vector>

#define vec vector
#define ll long long
#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define re return

using namespace std;

unordered_set<string> st1, st2;
map<string, int> mp1, mp2;

void add(string s, int t) {
	if (t == 1) {
		mp1[s]++;
		s += to_string(mp1[s]);
		st1.insert(s);
	}
	else {
		mp2[s]++;
		s += to_string(mp2[s]);
		st2.insert(s);
	}
}

string get_rand(int t) {
	string q;
	if (t == 1) {
		q = *st1.begin();
		st1.erase(st1.begin());
	}
	else {
		q = *st2.begin();
		st2.erase(st2.begin());
	}

	while (q.size() && q.back() >= '0' && q.back() <= '9')q.pop_back();

	re q;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	ll n = atoi(argv[1]);
	ll lword = atoi(argv[2]);
	ll rword = atoi(argv[3]);
	ll size = min(5'000'000ll, rnd.next(lword * n, rword * n));
	int rand = atoi(argv[4]);
	ll mxWord = atoi(argv[5]);

	if (rand) {
		cout << n << "\n";
		fori(n) {
			ll type = (rnd.next(0, rand) == 0);
			if (type == 1) {
				if (st1.size() != 0 && rnd.next(0, 1)) {
					cout << "1 - " << get_rand(1) << '\n';
				}
				else {
					ll r = min(rword, size - (n - i - 1));
					ll sz = rnd.next(lword, r);
					string tq = "";
					forj(sz) {
						tq += rnd.next('a', char('a' + mxWord));
					}

					cout << "1 + " << tq << "\n";
					add(tq, 1);
					size -= sz;
				}
			}
			else {
				if (st2.size() != 0 && rnd.next(0, 1)) {
					cout << "2 - " << get_rand(2) << '\n';
				}
				else {
					ll r = min(rword, size - (n - i - 1));
					ll sz = rnd.next(lword, r);
					string tq = "";
					forj(sz) {
						tq += rnd.next('a', char('a' + mxWord));
					}

					cout << "2 + " << tq << "\n";
					add(tq, 2);
					size -= sz;
				}
			}
		}
	}
	else {
		cout << n * 2 << "\n";
		fori(n) {
			ll type = rnd.next(0, 1);
			if (type == 0) {
				ll r = min(rword, size - (n - i - 1));
				ll sz = rnd.next(lword, r);
				string tq = "";
				forj(sz) {
					tq += rnd.next('a', char('a' + mxWord));
				}

				cout << "1 + " << tq << "\n";
				add(tq, 1);
				size -= sz;
			}
			else {
				ll r = min(rword, size - (n - i - 1));
				ll sz = rnd.next(lword, r);
				string tq = "";
				forj(sz) {
					tq += rnd.next('a', char('a' + mxWord));
				}

				cout << "2 + " << tq << "\n";
				add(tq, 2);
				size -= sz;
			}
		}

		fori(n) {
			ll type = rnd.next(0, 1);
			if (type == 0 && st1.size() != 0 || st2.size() == 0) {
				cout << "1 - " << get_rand(1) << '\n';
			}
			else {
				cout << "2 - " << get_rand(2) << '\n';
			}
		}
	}
}