/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

typedef unsigned long long ull;
typedef long double ld;

int main() {

#define SUBMIT(p) cout << "SUCCESS " << p << '\n'; cout.flush(); return 0;

    ull l = 1, r = 1000'000'000'000ll;

    string response;
    while (r - l > 1) {
        cout << "EXPERIMENT " << l << '\n';
        cout.flush();
        cin >> response;

        if (response == "BOOM") return 0;
        in(long double, x)
        ull new_r = static_cast<ull>(floor(x * l));
        if (static_cast<ld>(r) / l > x) r = new_r;
        ull new_l = static_cast<ull>(floor(sqrt(x) * l));
        if (new_l > l) l = new_l;
    }
    SUBMIT(r)

}