#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <random>
#include <cstring>
#include <numeric>
#include <queue>
#include <cassert>
#include <fstream>
#include <sstream>
#include <bitset>

using namespace std;

#define M_PI 3.14159265358979323846264338327950288419716939937510
#define inf 1e15
#define eps 1e-10
#define fori(n)for (long long i = 0; i < (n); i++)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define re return
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) ((n >> i) & 1)
#define ld long double
#define vec vector
#define unq(x) x.resize(unique(all(x)) - x.begin())

int __not_lg(ll n) { int cnt = 0; while (n /= 2) cnt++; re cnt; }
struct dsu {
	vector<int> v, cnt;
	void build(int n) { v.resize(n); cnt.resize(n); iota(all(v), 0); fill(all(cnt), 1); }
	dsu() {}
	dsu(int n) { build(n); }
	int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); re v[i]; }
	bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); re i1 == i2; }
	void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)re; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};

#ifdef LOCAL_BOBER
#define __lg(n) __not_lg(n)
#define asdasdasfasd ifstream fl("sample.io")
#define ffast_io ios::sync_with_stdio(false);\
				 cout.tie(nullptr)
#define cin fl
#else
#define asdasdasfasd //freopen("input.txt", "r", stdin);\
					 freopen("output.txt", "w", stdout);
#define ffast_io ios::sync_with_stdio(false);\
				 cout.tie(nullptr); cin.tie(nullptr)
#define tvq 100000
#endif

template<class T> T fast_pow(T n, ll p) { if (p == 1) re n; if (p % 2) re n* fast_pow(n, p - 1); re fast_pow(n * n, p / 2); }
template<class T> T mod_fast_pow(T n, T p, T m) { if (p == 0) re(T)1; if (p % 2 == 1) re n* mod_fast_pow(n, p - 1, m) % m; re mod_fast_pow(n * n % m, p / 2, m); }
template<class T> T gcd(T a, T b) { if (!a)re b; re gcd(b % a, a); }
template<class T> void umax(T& a, T b) { a = max(a, b); }
template<class T> void umin(T& a, T b) { a = min(a, b); }
template<class T> istream& operator >> (istream& o, vector<T>& x) { for (auto& el : x) o >> el; re o; }
template<class T, class U> istream& operator >> (istream& o, pair<T, U>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, pair<T, T>& x) { o >> x.first >> x.second; re o; }
template<class T, class U> pair<T, U> operator-(pair<T, U> a, pair<T, U> b) { return { a.first - b.first, a.second - b.second }; }
template<class T, class U> pair<T, U> operator+(pair<T, U> a, pair<T, U> b) { return { a.first + b.first, a.second + b.second }; }
template<class T> vector<T> operator+(vector<T> a, vector<T> b) { fori(a.size())a[i] += b[i]; re a; }
template<class T> vector<T> operator-(vector<T> a, vector<T> b) { fori(a.size())a[i] -= b[i]; re a; }
template<class T> string to_bin(T n) { string s = ""; while (n) { s = to_string(n % 2) + s; n >>= 1; } re s; }
template<class T> string fixed_to_bin(T n, ll q) { string s = "";  fori(q) { s = to_string(n % 2) + s; n >>= 1; } re s; }
ll from_bin(string s) { ll m = 0; fori(s.size()) { m = (m * 2) + s[i] - '0'; } re m; }
template<class T> int cnt_bit(T n) { int cnt = 0; while (n) { cnt += n % 2; n >>= 1; }re cnt; }

/*
	___        __              __   ______          __        _____ __             __          __  __
   /   | _____/ /___  ______ _/ /  / ____/___  ____/ /__     / ___// /_____ ______/ /______   / / / /__  ________
  / /| |/ ___/ __/ / / / __ `/ /  / /   / __ \/ __  / _ \    \__ \/ __/ __ `/ ___/ __/ ___/  / /_/ / _ \/ ___/ _ \
 / ___ / /__/ /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  __/   ___/ / /_/ /_/ / /  / /_(__  )  / __  /  __/ /  /  __/
/_/  |_\___/\__/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*///coating_len

random_device dev;
//mt19937 rd(dev());
mt19937 rd(42);

int main() {
	asdasdasfasd; ffast_io;

	int n; cin >> n;
	vec<ll> v(n);
	cin >> v;

	vec<ll> pref1(n + 1), sum1(n + 1); // sum1[i] -- pref[i]
	fori(n) {
		pref1[i + 1] = pref1[i] + v[i];
		sum1[i + 1] = sum1[i] + pref1[i + 1];
	}

	vec<ll> suff2(n + 1), sum2(n + 1);
	for (int i = n - 1; i >= 0; --i) {
		suff2[i] = suff2[i + 1] + v[i];
		sum2[i] = sum2[i + 1] + suff2[i];
	}

	ll ans = 1e18;
	fori(n) {
		umin(ans, sum1[i] + sum2[i + 1]);
	}
	cout << ans;
}