//#include "../testlib/testlib.h"
#include "testlib.h"

using namespace std;

// argv:
// . . n w c h
int main(int argc, char *argv[]) {
    // c -- коэффициент связности, 0-100, с какой вероятностью следующий отрезок будет пересекаться с предыдущим
    // h -- максимальная высота монитора, минимальная -- 0
    registerGen(argc, argv, 1);

    int n = opt<int>("n"), a = opt<int>("a"), b = opt<int>("b");
    int c = opt<int>("c"), h = opt<int>("h");

    println(n, a, b);

    int pl = -1, pr = -1;
    for (int i = 0; i < n; i++) {
        int low, high;
        if (pl == -1) {
            low = rnd.next(0, h - a);
            high = rnd.next(low + a, h);
        } else {
            int r = rnd.next(0, 100);
            if (r <= c) {
                r = rnd.next(0, 100);
                if (r <= 50) {
                    low = rnd.next(pl, min(pr, h - a));
                    high = rnd.next(low + a, h);
                } else {
                    high = rnd.next(max(pl, a), pr);
                    low = rnd.next(0, high - a);
                }
            } else {
                int hlb = min(pr, h - a);
                int lrb = max(pl, a);
                r = rnd.next(0, 100);
                if (h - a < pr) {
                    low = rnd.next(0, lrb - a);
                    high = rnd.next(low + a, lrb);
                } else if (a > pl) {
                    low = rnd.next(hlb, h - a);
                    high = rnd.next(low + a, h);
                } else {
                    if (r <= 50) {
                        low = rnd.next(0, lrb - a);
                        high = rnd.next(low + a, lrb);
                    } else {
                        low = rnd.next(hlb, h - a);
                        high = rnd.next(low + a, h);
                    }
                }
            }
        }
        println(low, high);
        pl = low;
        pr = high;
    }
}